/*===========================================================================*/
/*   (Unsafe/hmac.scm)                                                       */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -srfi enable-resolv -srfi enable-gmp -srfi enable-unistring -srfi enable-pcre -O3 -fcfa-arithmetic -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Unsafe/hmac.scm -o objs/obj_p/Unsafe/hmac.o) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif
static obj_t BGl_requirezd2initializa7ationz75zz__hmacz00 = BUNSPEC;
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__hmacz00();
extern obj_t BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_objectzd2initzd2zz__hmacz00();
static obj_t BGl_methodzd2initzd2zz__hmacz00();
extern obj_t make_string(long, unsigned char);
extern obj_t string_append(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__hmacz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__base64z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
static obj_t BGl_importedzd2moduleszd2initz00zz__hmacz00();
static obj_t BGl_gczd2rootszd2initz00zz__hmacz00();
BGL_EXPORTED_DECL obj_t BGl_hmaczd2stringzd2zz__hmacz00(obj_t, obj_t, obj_t);
extern obj_t blit_string(obj_t, long, obj_t, long, long);
static obj_t BGl_profzd2initzd2zz__hmacz00();
extern obj_t make_string_sans_fill(long);
static obj_t BGl_z62hmaczd2stringzb0zz__hmacz00(obj_t, obj_t, obj_t, obj_t);
static obj_t *__cnst;


DEFINE_STRING( BGl_string1624z00zz__hmacz00, BgL_bgl_string1624za700za7za7_1629za7, "/builddir/build/BUILD/bigloo4.3f/runtime/Unsafe/hmac.scm", 56 );
DEFINE_STRING( BGl_string1625z00zz__hmacz00, BgL_bgl_string1625za700za7za7_1630za7, "&hmac-string", 12 );
DEFINE_STRING( BGl_string1626z00zz__hmacz00, BgL_bgl_string1626za700za7za7_1631za7, "bstring", 7 );
DEFINE_STRING( BGl_string1627z00zz__hmacz00, BgL_bgl_string1627za700za7za7_1632za7, "procedure", 9 );
DEFINE_STRING( BGl_string1628z00zz__hmacz00, BgL_bgl_string1628za700za7za7_1633za7, "__hmac", 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_hmaczd2stringzd2envz00zz__hmacz00, BgL_bgl_za762hmacza7d2string1634z00, BGl_z62hmaczd2stringzb0zz__hmacz00, 0L, BUNSPEC, 3 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__hmacz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__hmacz00\")\n", (FILE *)bprof_port );
      fputs( "((\"hmac-string\" \"Unsafe/hmac.scm\" 1993) \"BGl_hmaczd2stringzd2zz__hmacz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&hmac-string\" \"Unsafe/hmac.scm\" 1993) \"BGl_z62hmaczd2stringzb0zz__hmacz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__hmacz00(long BgL_checksumz00_2006, char * BgL_fromz00_2007)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__hmacz00))
{ 
BGl_requirezd2initializa7ationz75zz__hmacz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__hmacz00(); 
BGl_importedzd2moduleszd2initz00zz__hmacz00(); 
return 
BGl_profzd2initzd2zz__hmacz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__hmacz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/hmac.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* prof-init */
obj_t BGl_profzd2initzd2zz__hmacz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/hmac.scm 15 */
return 
write_bprof_table();} 
BGL_FUNCTION_END;
}



/* hmac-string */
BGL_EXPORTED_DEF obj_t BGl_hmaczd2stringzd2zz__hmacz00(obj_t BgL_keyz00_3, obj_t BgL_messagez00_4, obj_t BgL_hashz00_5)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/hmac.scm 57 */
{ /* Unsafe/hmac.scm 61 */
obj_t BgL_keybz00_1224;
BgL_keybz00_1224 = 
make_string(((long)64), ((unsigned char)'\000')); 
{ /* Unsafe/hmac.scm 63 */
obj_t BgL_ixorz00_1225;
BgL_ixorz00_1225 = 
make_string_sans_fill(((long)64)); 
{ /* Unsafe/hmac.scm 64 */
obj_t BgL_oxorz00_1226;
BgL_oxorz00_1226 = 
make_string_sans_fill(((long)64)); 
{ /* Unsafe/hmac.scm 65 */

{ /* Unsafe/hmac.scm 67 */
long BgL_keyzd2lengthzd2_1227;
BgL_keyzd2lengthzd2_1227 = 
STRING_LENGTH(BgL_keyz00_3); 
if(
(BgL_keyzd2lengthzd2_1227>((long)64)))
{ /* Unsafe/hmac.scm 69 */
obj_t BgL_arg1154z00_1229;
{ /* Unsafe/hmac.scm 69 */
obj_t BgL_arg1155z00_1230;
BgL_arg1155z00_1230 = 
PROCEDURE_ENTRY(BgL_hashz00_5)(BgL_hashz00_5, BgL_keyz00_3, BEOA); 
BgL_arg1154z00_1229 = 
BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(BgL_arg1155z00_1230); } 
blit_string(BgL_arg1154z00_1229, ((long)0), BgL_keybz00_1224, ((long)0), ((long)16)); }  else 
{ /* Unsafe/hmac.scm 68 */
blit_string(BgL_keyz00_3, ((long)0), BgL_keybz00_1224, ((long)0), BgL_keyzd2lengthzd2_1227); } } 
{ 
long BgL_iz00_1232;
BgL_iz00_1232 = ((long)0); 
BgL_zc3anonymousza31156ze3z83_1233:
if(
(BgL_iz00_1232<((long)64)))
{ /* Unsafe/hmac.scm 74 */
long BgL_xiz00_1235;
BgL_xiz00_1235 = 
(
STRING_REF(BgL_keybz00_1224, BgL_iz00_1232)); 
{ /* Unsafe/hmac.scm 75 */
unsigned char BgL_tmpz00_2033;
BgL_tmpz00_2033 = 
(
(((long)54) ^ BgL_xiz00_1235)); 
STRING_SET(BgL_ixorz00_1225, BgL_iz00_1232, BgL_tmpz00_2033); } 
{ /* Unsafe/hmac.scm 76 */
unsigned char BgL_tmpz00_2037;
BgL_tmpz00_2037 = 
(
(((long)92) ^ BgL_xiz00_1235)); 
STRING_SET(BgL_oxorz00_1226, BgL_iz00_1232, BgL_tmpz00_2037); } 
{ 
long BgL_iz00_2041;
BgL_iz00_2041 = 
(BgL_iz00_1232+((long)1)); 
BgL_iz00_1232 = BgL_iz00_2041; 
goto BgL_zc3anonymousza31156ze3z83_1233;} }  else 
{ /* Unsafe/hmac.scm 73 */((bool_t)0); } } 
{ /* Unsafe/hmac.scm 82 */
obj_t BgL_arg1167z00_1243;
{ /* Unsafe/hmac.scm 82 */
obj_t BgL_arg1168z00_1244;
{ /* Unsafe/hmac.scm 82 */
obj_t BgL_arg1169z00_1245;
{ /* Unsafe/hmac.scm 82 */
obj_t BgL_arg1170z00_1246;
BgL_arg1170z00_1246 = 
string_append(BgL_ixorz00_1225, BgL_messagez00_4); 
BgL_arg1169z00_1245 = 
PROCEDURE_ENTRY(BgL_hashz00_5)(BgL_hashz00_5, BgL_arg1170z00_1246, BEOA); } 
BgL_arg1168z00_1244 = 
BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(BgL_arg1169z00_1245); } 
BgL_arg1167z00_1243 = 
string_append(BgL_oxorz00_1226, BgL_arg1168z00_1244); } 
return 
PROCEDURE_ENTRY(BgL_hashz00_5)(BgL_hashz00_5, BgL_arg1167z00_1243, BEOA);} } } } } } 
BGL_FUNCTION_END;
}



/* &hmac-string */
obj_t BGl_z62hmaczd2stringzb0zz__hmacz00(obj_t BgL_envz00_1996, obj_t BgL_keyz00_1997, obj_t BgL_messagez00_1998, obj_t BgL_hashz00_1999)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/hmac.scm 57 */
{ /* Unsafe/hmac.scm 59 */
obj_t BgL_auxz00_2068;obj_t BgL_auxz00_2061;obj_t BgL_auxz00_2054;
if(
PROCEDUREP(BgL_hashz00_1999))
{ /* Unsafe/hmac.scm 59 */
BgL_auxz00_2068 = BgL_hashz00_1999
; }  else 
{ 
obj_t BgL_auxz00_2071;
BgL_auxz00_2071 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1624z00zz__hmacz00, 
BINT(((long)2036)), BGl_string1625z00zz__hmacz00, BGl_string1627z00zz__hmacz00, BgL_hashz00_1999); 
FAILURE(BgL_auxz00_2071,BFALSE,BFALSE);} 
if(
STRINGP(BgL_messagez00_1998))
{ /* Unsafe/hmac.scm 59 */
BgL_auxz00_2061 = BgL_messagez00_1998
; }  else 
{ 
obj_t BgL_auxz00_2064;
BgL_auxz00_2064 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1624z00zz__hmacz00, 
BINT(((long)2036)), BGl_string1625z00zz__hmacz00, BGl_string1626z00zz__hmacz00, BgL_messagez00_1998); 
FAILURE(BgL_auxz00_2064,BFALSE,BFALSE);} 
if(
STRINGP(BgL_keyz00_1997))
{ /* Unsafe/hmac.scm 59 */
BgL_auxz00_2054 = BgL_keyz00_1997
; }  else 
{ 
obj_t BgL_auxz00_2057;
BgL_auxz00_2057 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1624z00zz__hmacz00, 
BINT(((long)2036)), BGl_string1625z00zz__hmacz00, BGl_string1626z00zz__hmacz00, BgL_keyz00_1997); 
FAILURE(BgL_auxz00_2057,BFALSE,BFALSE);} 
return 
BGl_hmaczd2stringzd2zz__hmacz00(BgL_auxz00_2054, BgL_auxz00_2061, BgL_auxz00_2068);} } 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__hmacz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/hmac.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__hmacz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/hmac.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__hmacz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/hmac.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__hmacz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/hmac.scm 15 */
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string1628z00zz__hmacz00)); 
return 
BGl_modulezd2initializa7ationz75zz__base64z00(((long)67813413), 
BSTRING_TO_STRING(BGl_string1628z00zz__hmacz00));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
