/*===========================================================================*/
/*   (Unsafe/regexp.scm)                                                     */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -srfi enable-resolv -srfi enable-gmp -srfi enable-unistring -srfi enable-pcre -O3 -fcfa-arithmetic -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Unsafe/regexp.scm -o objs/obj_p/Unsafe/regexp.o) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif
BGL_EXPORTED_DECL obj_t BGl_regexpzd2patternzd2zz__regexpz00(obj_t);
static obj_t BGl_z62regexpzf3z91zz__regexpz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__regexpz00 = BUNSPEC;
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62pregexpzd2quotezb0zz__regexpz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__regexpz00();
static obj_t BGl__pregexpzd2matchzd2positionsz00zz__regexpz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__regexpz00();
extern obj_t BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_memvz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_pregexpz00zz__regexpz00(obj_t, obj_t);
extern obj_t bgl_reverse_bang(obj_t);
extern obj_t string_append_3(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_pregexpzd2replacezd2zz__regexpz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62pregexpzd2replacezb0zz__regexpz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__regexpz00();
static obj_t BGl_z62pregexpzd2splitzb0zz__regexpz00(obj_t, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t BGl_stringzd2ze3numberz31zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_pregexpzd2quotezd2zz__regexpz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_regexpzf3zf3zz__regexpz00(obj_t);
static obj_t BGl_pregexpzd2readzd2escapedzd2numberzd2zz__regexpz00(obj_t, obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__regexpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_matchz00zz__regexpz00(obj_t, obj_t, bool_t, obj_t, obj_t);
static obj_t BGl_pregexpzd2listzd2refz00zz__regexpz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_pregexpzd2replaceza2z70zz__regexpz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL long BGl_pregexpzd2matchzd2nzd2positionsz12zc0zz__regexpz00(obj_t, obj_t, obj_t, long, long);
BGL_EXPORTED_DECL obj_t BGl_pregexpzd2matchzd2positionsz00zz__regexpz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__regexpz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__regexpz00();
static obj_t BGl_z62pregexpzd2matchzd2nzd2positionsz12za2zz__regexpz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__regexpz00();
static obj_t BGl_list1784z00zz__regexpz00 = BUNSPEC;
static obj_t BGl_pregexpzd2replacezd2auxz00zz__regexpz00(obj_t, obj_t, long, obj_t);
static obj_t BGl__pregexpzd2matchzd2zz__regexpz00(obj_t, obj_t);
static obj_t BGl_z62pregexpz62zz__regexpz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_pregexpzd2splitzd2zz__regexpz00(obj_t, obj_t);
extern obj_t bgl_regcomp(obj_t, obj_t);
static obj_t BGl_z62pregexpzd2replaceza2z12zz__regexpz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62regexpzd2patternzb0zz__regexpz00(obj_t, obj_t);
static obj_t BGl_profzd2initzd2zz__regexpz00();
BGL_EXPORTED_DECL obj_t BGl_pregexpzd2matchzd2zz__regexpz00(obj_t, obj_t, obj_t, obj_t);
static obj_t *__cnst;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_pregexpzd2splitzd2envz00zz__regexpz00, BgL_bgl_za762pregexpza7d2spl1787z00, BGl_z62pregexpzd2splitzb0zz__regexpz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pregexpzd2quotezd2envz00zz__regexpz00, BgL_bgl_za762pregexpza7d2quo1788z00, BGl_z62pregexpzd2quotezb0zz__regexpz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pregexpzd2replaceza2zd2envza2zz__regexpz00, BgL_bgl_za762pregexpza7d2rep1789z00, BGl_z62pregexpzd2replaceza2z12zz__regexpz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pregexpzd2matchzd2nzd2positionsz12zd2envz12zz__regexpz00, BgL_bgl_za762pregexpza7d2mat1790z00, BGl_z62pregexpzd2matchzd2nzd2positionsz12za2zz__regexpz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string1770z00zz__regexpz00, BgL_bgl_string1770za700za7za7_1791za7, "/builddir/build/BUILD/bigloo4.3f/runtime/Unsafe/regexp.scm", 58 );
DEFINE_STRING( BGl_string1771z00zz__regexpz00, BgL_bgl_string1771za700za7za7_1792za7, "&regexp-pattern", 15 );
DEFINE_STRING( BGl_string1772z00zz__regexpz00, BgL_bgl_string1772za700za7za7_1793za7, "regexp", 6 );
DEFINE_STRING( BGl_string1773z00zz__regexpz00, BgL_bgl_string1773za700za7za7_1794za7, "&pregexp", 8 );
DEFINE_STRING( BGl_string1774z00zz__regexpz00, BgL_bgl_string1774za700za7za7_1795za7, "bstring", 7 );
DEFINE_STRING( BGl_string1775z00zz__regexpz00, BgL_bgl_string1775za700za7za7_1796za7, "_pregexp-match-positions", 24 );
DEFINE_STRING( BGl_string1776z00zz__regexpz00, BgL_bgl_string1776za700za7za7_1797za7, "&pregexp-match-n-positions!", 27 );
DEFINE_STRING( BGl_string1777z00zz__regexpz00, BgL_bgl_string1777za700za7za7_1798za7, "vector", 6 );
DEFINE_STRING( BGl_string1778z00zz__regexpz00, BgL_bgl_string1778za700za7za7_1799za7, "bint", 4 );
DEFINE_STRING( BGl_string1779z00zz__regexpz00, BgL_bgl_string1779za700za7za7_1800za7, "_pregexp-match", 14 );
DEFINE_STRING( BGl_string1780z00zz__regexpz00, BgL_bgl_string1780za700za7za7_1801za7, "", 0 );
DEFINE_STRING( BGl_string1781z00zz__regexpz00, BgL_bgl_string1781za700za7za7_1802za7, "&pregexp-split", 14 );
DEFINE_STRING( BGl_string1782z00zz__regexpz00, BgL_bgl_string1782za700za7za7_1803za7, "&pregexp-replace", 16 );
DEFINE_STRING( BGl_string1783z00zz__regexpz00, BgL_bgl_string1783za700za7za7_1804za7, "&pregexp-replace*", 17 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pregexpzd2matchzd2envz00zz__regexpz00, BgL_bgl__pregexpza7d2match1805za7, opt_generic_entry, BGl__pregexpzd2matchzd2zz__regexpz00, BFALSE, -1 );
DEFINE_STRING( BGl_string1785z00zz__regexpz00, BgL_bgl_string1785za700za7za7_1806za7, "&pregexp-quote", 14 );
DEFINE_STRING( BGl_string1786z00zz__regexpz00, BgL_bgl_string1786za700za7za7_1807za7, "__regexp", 8 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pregexpzd2envzd2zz__regexpz00, BgL_bgl_za762pregexpza762za7za7_1808z00, va_generic_entry, BGl_z62pregexpz62zz__regexpz00, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_regexpzd2patternzd2envz00zz__regexpz00, BgL_bgl_za762regexpza7d2patt1809z00, BGl_z62regexpzd2patternzb0zz__regexpz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pregexpzd2replacezd2envz00zz__regexpz00, BgL_bgl_za762pregexpza7d2rep1810z00, BGl_z62pregexpzd2replacezb0zz__regexpz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_regexpzf3zd2envz21zz__regexpz00, BgL_bgl_za762regexpza7f3za791za71811z00, BGl_z62regexpzf3z91zz__regexpz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pregexpzd2matchzd2positionszd2envzd2zz__regexpz00, BgL_bgl__pregexpza7d2match1812za7, opt_generic_entry, BGl__pregexpzd2matchzd2positionsz00zz__regexpz00, BFALSE, -1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__regexpz00) );
ADD_ROOT( (void *)(&BGl_list1784z00zz__regexpz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"regexp?\" \"Unsafe/regexp.scm\" 3680) \"BGl_regexpzf3zf3zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&regexp?\" \"Unsafe/regexp.scm\" 3680) \"BGl_z62regexpzf3z91zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"regexp-pattern\" \"Unsafe/regexp.scm\" 3951) \"BGl_regexpzd2patternzd2zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&regexp-pattern\" \"Unsafe/regexp.scm\" 3951) \"BGl_z62regexpzd2patternzb0zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp\" \"Unsafe/regexp.scm\" 4578) \"BGl_pregexpz00zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&pregexp\" \"Unsafe/regexp.scm\" 4578) \"BGl_z62pregexpz62zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"match\" \"Unsafe/regexp.scm\" 4860) \"BGl_matchz00zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"_pregexp-match-positions\" \"Unsafe/regexp.scm\" 5296) \"BGl__pregexpzd2matchzd2positionsz00zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-match-positions\" \"Unsafe/regexp.scm\" 5296) \"BGl_pregexpzd2matchzd2positionsz00zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-match-n-positions!\" \"Unsafe/regexp.scm\" 5637) \"BGl_pregexpzd2matchzd2nzd2positionsz12zc0zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&pregexp-match-n-positions!\" \"Unsafe/regexp.scm\" 5637) \"BGl_z62pregexpzd2matchzd2nzd2positionsz12za2zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"_pregexp-match\" \"Unsafe/regexp.scm\" 5972) \"BGl__pregexpzd2matchzd2zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-match\" \"Unsafe/regexp.scm\" 5972) \"BGl_pregexpzd2matchzd2zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-read-escaped-number\" \"Unsafe/regexp.scm\" 6303) \"BGl_pregexpzd2readzd2escapedzd2numberzd2zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-list-ref\" \"Unsafe/regexp.scm\" 7005) \"BGl_pregexpzd2listzd2refz00zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-replace-aux\" \"Unsafe/regexp.scm\" 7437) \"BGl_pregexpzd2replacezd2auxz00zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-split\" \"Unsafe/regexp.scm\" 8409) \"BGl_pregexpzd2splitzd2zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&pregexp-split\" \"Unsafe/regexp.scm\" 8409) \"BGl_z62pregexpzd2splitzb0zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-replace\" \"Unsafe/regexp.scm\" 9273) \"BGl_pregexpzd2replacezd2zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&pregexp-replace\" \"Unsafe/regexp.scm\" 9273) \"BGl_z62pregexpzd2replacezb0zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-replace*\" \"Unsafe/regexp.scm\" 9831) \"BGl_pregexpzd2replaceza2z70zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&pregexp-replace*\" \"Unsafe/regexp.scm\" 9831) \"BGl_z62pregexpzd2replaceza2z12zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"pregexp-quote\" \"Unsafe/regexp.scm\" 10870) \"BGl_pregexpzd2quotezd2zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&pregexp-quote\" \"Unsafe/regexp.scm\" 10870) \"BGl_z62pregexpzd2quotezb0zz__regexpz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__regexpz00(long BgL_checksumz00_2029, char * BgL_fromz00_2030)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__regexpz00))
{ 
BGl_requirezd2initializa7ationz75zz__regexpz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__regexpz00(); 
BGl_cnstzd2initzd2zz__regexpz00(); 
BGl_importedzd2moduleszd2initz00zz__regexpz00(); 
return 
BGl_profzd2initzd2zz__regexpz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__regexpz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 16 */
return ( 
BGl_list1784z00zz__regexpz00 = 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'\\')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'.')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'?')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'*')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'+')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'|')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'^')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'$')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'[')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)']')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'{')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'}')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'(')), 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)')')), BNIL)))))))))))))), BUNSPEC) ;} 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__regexpz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 16 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* prof-init */
obj_t BGl_profzd2initzd2zz__regexpz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 16 */
return 
write_bprof_table();} 
BGL_FUNCTION_END;
}



/* regexp? */
BGL_EXPORTED_DEF bool_t BGl_regexpzf3zf3zz__regexpz00(obj_t BgL_objz00_3)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 88 */
return 
BGL_REGEXPP(BgL_objz00_3);} 
BGL_FUNCTION_END;
}



/* &regexp? */
obj_t BGl_z62regexpzf3z91zz__regexpz00(obj_t BgL_envz00_1957, obj_t BgL_objz00_1958)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 88 */
return 
BBOOL(
BGl_regexpzf3zf3zz__regexpz00(BgL_objz00_1958));} 
BGL_FUNCTION_END;
}



/* regexp-pattern */
BGL_EXPORTED_DEF obj_t BGl_regexpzd2patternzd2zz__regexpz00(obj_t BgL_rez00_4)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 94 */
return 
BGL_REGEXP_PAT(BgL_rez00_4);} 
BGL_FUNCTION_END;
}



/* &regexp-pattern */
obj_t BGl_z62regexpzd2patternzb0zz__regexpz00(obj_t BgL_envz00_1959, obj_t BgL_rez00_1960)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 94 */
{ /* Unsafe/regexp.scm 95 */
obj_t BgL_auxz00_2072;
if(
BGl_regexpzf3zf3zz__regexpz00(BgL_rez00_1960))
{ /* Unsafe/regexp.scm 95 */
BgL_auxz00_2072 = BgL_rez00_1960
; }  else 
{ 
obj_t BgL_auxz00_2075;
BgL_auxz00_2075 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)3989)), BGl_string1771z00zz__regexpz00, BGl_string1772z00zz__regexpz00, BgL_rez00_1960); 
FAILURE(BgL_auxz00_2075,BFALSE,BFALSE);} 
return 
BGl_regexpzd2patternzd2zz__regexpz00(BgL_auxz00_2072);} } 
BGL_FUNCTION_END;
}



/* pregexp */
BGL_EXPORTED_DEF obj_t BGl_pregexpz00zz__regexpz00(obj_t BgL_rez00_5, obj_t BgL_optzd2argszd2_6)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 109 */
return 
bgl_regcomp(BgL_rez00_5, BgL_optzd2argszd2_6);} 
BGL_FUNCTION_END;
}



/* &pregexp */
obj_t BGl_z62pregexpz62zz__regexpz00(obj_t BgL_envz00_1961, obj_t BgL_rez00_1962, obj_t BgL_optzd2argszd2_1963)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 109 */
{ /* Unsafe/regexp.scm 110 */
obj_t BgL_auxz00_2081;
if(
STRINGP(BgL_rez00_1962))
{ /* Unsafe/regexp.scm 110 */
BgL_auxz00_2081 = BgL_rez00_1962
; }  else 
{ 
obj_t BgL_auxz00_2084;
BgL_auxz00_2084 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)4613)), BGl_string1773z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_rez00_1962); 
FAILURE(BgL_auxz00_2084,BFALSE,BFALSE);} 
return 
BGl_pregexpz00zz__regexpz00(BgL_auxz00_2081, BgL_optzd2argszd2_1963);} } 
BGL_FUNCTION_END;
}



/* match */
obj_t BGl_matchz00zz__regexpz00(obj_t BgL_patz00_7, obj_t BgL_strz00_8, bool_t BgL_stringpz00_9, obj_t BgL_begz00_10, obj_t BgL_endz00_11)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 115 */
{ /* Unsafe/regexp.scm 116 */
bool_t BgL_testz00_2089;
{ /* Unsafe/regexp.scm 116 */
bool_t BgL_res1613z00_1533;
BgL_res1613z00_1533 = 
BGL_REGEXPP(BgL_patz00_7); 
BgL_testz00_2089 = BgL_res1613z00_1533; } 
if(BgL_testz00_2089)
{ /* Unsafe/regexp.scm 117 */
int BgL_auxz00_2095;int BgL_auxz00_2093;char * BgL_tmpz00_2091;
BgL_auxz00_2095 = 
CINT(BgL_endz00_11); 
BgL_auxz00_2093 = 
CINT(BgL_begz00_10); 
BgL_tmpz00_2091 = 
BSTRING_TO_STRING(BgL_strz00_8); 
return 
BGL_REGEXP_MATCH(BgL_patz00_7, BgL_tmpz00_2091, BgL_stringpz00_9, BgL_auxz00_2093, BgL_auxz00_2095);}  else 
{ /* Unsafe/regexp.scm 118 */
obj_t BgL_rxz00_976;
BgL_rxz00_976 = 
bgl_regcomp(
((obj_t)BgL_patz00_7), BNIL); 
{ /* Unsafe/regexp.scm 118 */
obj_t BgL_valz00_977;
{ /* Unsafe/regexp.scm 119 */
int BgL_auxz00_2104;int BgL_auxz00_2102;char * BgL_tmpz00_2100;
BgL_auxz00_2104 = 
CINT(BgL_endz00_11); 
BgL_auxz00_2102 = 
CINT(BgL_begz00_10); 
BgL_tmpz00_2100 = 
BSTRING_TO_STRING(BgL_strz00_8); 
BgL_valz00_977 = 
BGL_REGEXP_MATCH(BgL_rxz00_976, BgL_tmpz00_2100, BgL_stringpz00_9, BgL_auxz00_2102, BgL_auxz00_2104); } 
{ /* Unsafe/regexp.scm 119 */

BGL_REGEXP_FREE(BgL_rxz00_976); 
return BgL_valz00_977;} } } } } 
BGL_FUNCTION_END;
}



/* _pregexp-match-positions */
obj_t BGl__pregexpzd2matchzd2positionsz00zz__regexpz00(obj_t BgL_envz00_17, obj_t BgL_optz00_16)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 126 */
{ /* Unsafe/regexp.scm 126 */
obj_t BgL_patz00_979;obj_t BgL_strz00_980;
BgL_patz00_979 = 
VECTOR_REF(BgL_optz00_16,((long)0)); 
BgL_strz00_980 = 
VECTOR_REF(BgL_optz00_16,((long)1)); 
switch( 
VECTOR_LENGTH(BgL_optz00_16)) { case ((long)2) : 

{ /* Unsafe/regexp.scm 126 */
long BgL_endz00_985;
{ /* Unsafe/regexp.scm 126 */
obj_t BgL_stringz00_1535;
if(
STRINGP(BgL_strz00_980))
{ /* Unsafe/regexp.scm 126 */
BgL_stringz00_1535 = BgL_strz00_980; }  else 
{ 
obj_t BgL_auxz00_2112;
BgL_auxz00_2112 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5361)), BGl_string1775z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_980); 
FAILURE(BgL_auxz00_2112,BFALSE,BFALSE);} 
BgL_endz00_985 = 
STRING_LENGTH(BgL_stringz00_1535); } 
{ /* Unsafe/regexp.scm 126 */

{ /* Unsafe/regexp.scm 126 */
obj_t BgL_auxz00_2117;
if(
STRINGP(BgL_strz00_980))
{ /* Unsafe/regexp.scm 126 */
BgL_auxz00_2117 = BgL_strz00_980
; }  else 
{ 
obj_t BgL_auxz00_2120;
BgL_auxz00_2120 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5296)), BGl_string1775z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_980); 
FAILURE(BgL_auxz00_2120,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2matchzd2positionsz00zz__regexpz00(BgL_patz00_979, BgL_auxz00_2117, 
BINT(((long)0)), 
BINT(BgL_endz00_985));} } } break;case ((long)3) : 

{ /* Unsafe/regexp.scm 126 */
obj_t BgL_begz00_986;
BgL_begz00_986 = 
VECTOR_REF(BgL_optz00_16,((long)2)); 
{ /* Unsafe/regexp.scm 126 */
long BgL_endz00_987;
{ /* Unsafe/regexp.scm 126 */
obj_t BgL_stringz00_1537;
if(
STRINGP(BgL_strz00_980))
{ /* Unsafe/regexp.scm 126 */
BgL_stringz00_1537 = BgL_strz00_980; }  else 
{ 
obj_t BgL_auxz00_2130;
BgL_auxz00_2130 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5361)), BGl_string1775z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_980); 
FAILURE(BgL_auxz00_2130,BFALSE,BFALSE);} 
BgL_endz00_987 = 
STRING_LENGTH(BgL_stringz00_1537); } 
{ /* Unsafe/regexp.scm 126 */

{ /* Unsafe/regexp.scm 126 */
obj_t BgL_auxz00_2135;
if(
STRINGP(BgL_strz00_980))
{ /* Unsafe/regexp.scm 126 */
BgL_auxz00_2135 = BgL_strz00_980
; }  else 
{ 
obj_t BgL_auxz00_2138;
BgL_auxz00_2138 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5296)), BGl_string1775z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_980); 
FAILURE(BgL_auxz00_2138,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2matchzd2positionsz00zz__regexpz00(BgL_patz00_979, BgL_auxz00_2135, BgL_begz00_986, 
BINT(BgL_endz00_987));} } } } break;case ((long)4) : 

{ /* Unsafe/regexp.scm 126 */
obj_t BgL_begz00_988;
BgL_begz00_988 = 
VECTOR_REF(BgL_optz00_16,((long)2)); 
{ /* Unsafe/regexp.scm 126 */
obj_t BgL_endz00_989;
BgL_endz00_989 = 
VECTOR_REF(BgL_optz00_16,((long)3)); 
{ /* Unsafe/regexp.scm 126 */

{ /* Unsafe/regexp.scm 126 */
obj_t BgL_auxz00_2146;
if(
STRINGP(BgL_strz00_980))
{ /* Unsafe/regexp.scm 126 */
BgL_auxz00_2146 = BgL_strz00_980
; }  else 
{ 
obj_t BgL_auxz00_2149;
BgL_auxz00_2149 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5296)), BGl_string1775z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_980); 
FAILURE(BgL_auxz00_2149,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2matchzd2positionsz00zz__regexpz00(BgL_patz00_979, BgL_auxz00_2146, BgL_begz00_988, BgL_endz00_989);} } } } break;
default: 
return BUNSPEC;} } } 
BGL_FUNCTION_END;
}



/* pregexp-match-positions */
BGL_EXPORTED_DEF obj_t BGl_pregexpzd2matchzd2positionsz00zz__regexpz00(obj_t BgL_patz00_12, obj_t BgL_strz00_13, obj_t BgL_begz00_14, obj_t BgL_endz00_15)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 126 */
return 
BGl_matchz00zz__regexpz00(BgL_patz00_12, BgL_strz00_13, ((bool_t)0), BgL_begz00_14, BgL_endz00_15);} 
BGL_FUNCTION_END;
}



/* pregexp-match-n-positions! */
BGL_EXPORTED_DEF long BGl_pregexpzd2matchzd2nzd2positionsz12zc0zz__regexpz00(obj_t BgL_patz00_18, obj_t BgL_strz00_19, obj_t BgL_vresz00_20, long BgL_begz00_21, long BgL_endz00_22)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 132 */
{ /* Unsafe/regexp.scm 133 */
int BgL_auxz00_2161;int BgL_auxz00_2159;char * BgL_tmpz00_2157;
BgL_auxz00_2161 = 
(int)(BgL_endz00_22); 
BgL_auxz00_2159 = 
(int)(BgL_begz00_21); 
BgL_tmpz00_2157 = 
BSTRING_TO_STRING(BgL_strz00_19); 
return 
BGL_REGEXP_MATCH_N(BgL_patz00_18, BgL_tmpz00_2157, BgL_vresz00_20, BgL_auxz00_2159, BgL_auxz00_2161);} } 
BGL_FUNCTION_END;
}



/* &pregexp-match-n-positions! */
obj_t BGl_z62pregexpzd2matchzd2nzd2positionsz12za2zz__regexpz00(obj_t BgL_envz00_1964, obj_t BgL_patz00_1965, obj_t BgL_strz00_1966, obj_t BgL_vresz00_1967, obj_t BgL_begz00_1968, obj_t BgL_endz00_1969)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 132 */
{ /* Unsafe/regexp.scm 133 */
long BgL_tmpz00_2164;
{ /* Unsafe/regexp.scm 133 */
long BgL_auxz00_2195;long BgL_auxz00_2186;obj_t BgL_auxz00_2179;obj_t BgL_auxz00_2172;obj_t BgL_auxz00_2165;
{ /* Unsafe/regexp.scm 133 */
obj_t BgL_tmpz00_2196;
if(
INTEGERP(BgL_endz00_1969))
{ /* Unsafe/regexp.scm 133 */
BgL_tmpz00_2196 = BgL_endz00_1969
; }  else 
{ 
obj_t BgL_auxz00_2199;
BgL_auxz00_2199 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5713)), BGl_string1776z00zz__regexpz00, BGl_string1778z00zz__regexpz00, BgL_endz00_1969); 
FAILURE(BgL_auxz00_2199,BFALSE,BFALSE);} 
BgL_auxz00_2195 = 
(long)CINT(BgL_tmpz00_2196); } 
{ /* Unsafe/regexp.scm 133 */
obj_t BgL_tmpz00_2187;
if(
INTEGERP(BgL_begz00_1968))
{ /* Unsafe/regexp.scm 133 */
BgL_tmpz00_2187 = BgL_begz00_1968
; }  else 
{ 
obj_t BgL_auxz00_2190;
BgL_auxz00_2190 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5713)), BGl_string1776z00zz__regexpz00, BGl_string1778z00zz__regexpz00, BgL_begz00_1968); 
FAILURE(BgL_auxz00_2190,BFALSE,BFALSE);} 
BgL_auxz00_2186 = 
(long)CINT(BgL_tmpz00_2187); } 
if(
VECTORP(BgL_vresz00_1967))
{ /* Unsafe/regexp.scm 133 */
BgL_auxz00_2179 = BgL_vresz00_1967
; }  else 
{ 
obj_t BgL_auxz00_2182;
BgL_auxz00_2182 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5713)), BGl_string1776z00zz__regexpz00, BGl_string1777z00zz__regexpz00, BgL_vresz00_1967); 
FAILURE(BgL_auxz00_2182,BFALSE,BFALSE);} 
if(
STRINGP(BgL_strz00_1966))
{ /* Unsafe/regexp.scm 133 */
BgL_auxz00_2172 = BgL_strz00_1966
; }  else 
{ 
obj_t BgL_auxz00_2175;
BgL_auxz00_2175 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5713)), BGl_string1776z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_1966); 
FAILURE(BgL_auxz00_2175,BFALSE,BFALSE);} 
if(
BGl_regexpzf3zf3zz__regexpz00(BgL_patz00_1965))
{ /* Unsafe/regexp.scm 133 */
BgL_auxz00_2165 = BgL_patz00_1965
; }  else 
{ 
obj_t BgL_auxz00_2168;
BgL_auxz00_2168 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5713)), BGl_string1776z00zz__regexpz00, BGl_string1772z00zz__regexpz00, BgL_patz00_1965); 
FAILURE(BgL_auxz00_2168,BFALSE,BFALSE);} 
BgL_tmpz00_2164 = 
BGl_pregexpzd2matchzd2nzd2positionsz12zc0zz__regexpz00(BgL_auxz00_2165, BgL_auxz00_2172, BgL_auxz00_2179, BgL_auxz00_2186, BgL_auxz00_2195); } 
return 
BINT(BgL_tmpz00_2164);} } 
BGL_FUNCTION_END;
}



/* _pregexp-match */
obj_t BGl__pregexpzd2matchzd2zz__regexpz00(obj_t BgL_envz00_28, obj_t BgL_optz00_27)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 138 */
{ /* Unsafe/regexp.scm 138 */
obj_t BgL_patz00_990;obj_t BgL_strz00_991;
BgL_patz00_990 = 
VECTOR_REF(BgL_optz00_27,((long)0)); 
BgL_strz00_991 = 
VECTOR_REF(BgL_optz00_27,((long)1)); 
switch( 
VECTOR_LENGTH(BgL_optz00_27)) { case ((long)2) : 

{ /* Unsafe/regexp.scm 138 */
long BgL_endz00_996;
{ /* Unsafe/regexp.scm 138 */
obj_t BgL_stringz00_1539;
if(
STRINGP(BgL_strz00_991))
{ /* Unsafe/regexp.scm 138 */
BgL_stringz00_1539 = BgL_strz00_991; }  else 
{ 
obj_t BgL_auxz00_2210;
BgL_auxz00_2210 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)6027)), BGl_string1779z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_991); 
FAILURE(BgL_auxz00_2210,BFALSE,BFALSE);} 
BgL_endz00_996 = 
STRING_LENGTH(BgL_stringz00_1539); } 
{ /* Unsafe/regexp.scm 138 */

{ /* Unsafe/regexp.scm 138 */
obj_t BgL_auxz00_2215;
if(
STRINGP(BgL_strz00_991))
{ /* Unsafe/regexp.scm 138 */
BgL_auxz00_2215 = BgL_strz00_991
; }  else 
{ 
obj_t BgL_auxz00_2218;
BgL_auxz00_2218 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5972)), BGl_string1779z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_991); 
FAILURE(BgL_auxz00_2218,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_990, BgL_auxz00_2215, 
BINT(((long)0)), 
BINT(BgL_endz00_996));} } } break;case ((long)3) : 

{ /* Unsafe/regexp.scm 138 */
obj_t BgL_begz00_997;
BgL_begz00_997 = 
VECTOR_REF(BgL_optz00_27,((long)2)); 
{ /* Unsafe/regexp.scm 138 */
long BgL_endz00_998;
{ /* Unsafe/regexp.scm 138 */
obj_t BgL_stringz00_1541;
if(
STRINGP(BgL_strz00_991))
{ /* Unsafe/regexp.scm 138 */
BgL_stringz00_1541 = BgL_strz00_991; }  else 
{ 
obj_t BgL_auxz00_2228;
BgL_auxz00_2228 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)6027)), BGl_string1779z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_991); 
FAILURE(BgL_auxz00_2228,BFALSE,BFALSE);} 
BgL_endz00_998 = 
STRING_LENGTH(BgL_stringz00_1541); } 
{ /* Unsafe/regexp.scm 138 */

{ /* Unsafe/regexp.scm 138 */
obj_t BgL_auxz00_2233;
if(
STRINGP(BgL_strz00_991))
{ /* Unsafe/regexp.scm 138 */
BgL_auxz00_2233 = BgL_strz00_991
; }  else 
{ 
obj_t BgL_auxz00_2236;
BgL_auxz00_2236 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5972)), BGl_string1779z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_991); 
FAILURE(BgL_auxz00_2236,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_990, BgL_auxz00_2233, BgL_begz00_997, 
BINT(BgL_endz00_998));} } } } break;case ((long)4) : 

{ /* Unsafe/regexp.scm 138 */
obj_t BgL_begz00_999;
BgL_begz00_999 = 
VECTOR_REF(BgL_optz00_27,((long)2)); 
{ /* Unsafe/regexp.scm 138 */
obj_t BgL_endz00_1000;
BgL_endz00_1000 = 
VECTOR_REF(BgL_optz00_27,((long)3)); 
{ /* Unsafe/regexp.scm 138 */

{ /* Unsafe/regexp.scm 138 */
obj_t BgL_auxz00_2244;
if(
STRINGP(BgL_strz00_991))
{ /* Unsafe/regexp.scm 138 */
BgL_auxz00_2244 = BgL_strz00_991
; }  else 
{ 
obj_t BgL_auxz00_2247;
BgL_auxz00_2247 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)5972)), BGl_string1779z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_991); 
FAILURE(BgL_auxz00_2247,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_990, BgL_auxz00_2244, BgL_begz00_999, BgL_endz00_1000);} } } } break;
default: 
return BUNSPEC;} } } 
BGL_FUNCTION_END;
}



/* pregexp-match */
BGL_EXPORTED_DEF obj_t BGl_pregexpzd2matchzd2zz__regexpz00(obj_t BgL_patz00_23, obj_t BgL_strz00_24, obj_t BgL_begz00_25, obj_t BgL_endz00_26)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 138 */
return 
BGl_matchz00zz__regexpz00(BgL_patz00_23, BgL_strz00_24, ((bool_t)1), BgL_begz00_25, BgL_endz00_26);} 
BGL_FUNCTION_END;
}



/* pregexp-read-escaped-number */
obj_t BGl_pregexpzd2readzd2escapedzd2numberzd2zz__regexpz00(obj_t BgL_sz00_29, obj_t BgL_iz00_30, long BgL_nz00_31)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 144 */
if(
(
(
(long)CINT(BgL_iz00_30)+((long)1))<BgL_nz00_31))
{ /* Unsafe/regexp.scm 147 */
unsigned char BgL_cz00_1002;
BgL_cz00_1002 = 
STRING_REF(BgL_sz00_29, 
(
(long)CINT(BgL_iz00_30)+((long)1))); 
{ /* Unsafe/regexp.scm 148 */
bool_t BgL_testz00_2262;
{ /* Unsafe/regexp.scm 148 */
bool_t BgL_res1622z00_1554;
BgL_res1622z00_1554 = 
isdigit(BgL_cz00_1002); 
BgL_testz00_2262 = BgL_res1622z00_1554; } 
if(BgL_testz00_2262)
{ /* Unsafe/regexp.scm 149 */
long BgL_g1044z00_1004;obj_t BgL_g1045z00_1005;
BgL_g1044z00_1004 = 
(
(long)CINT(BgL_iz00_30)+((long)2)); 
{ /* Unsafe/regexp.scm 149 */
obj_t BgL_list1190z00_1030;
BgL_list1190z00_1030 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_cz00_1002), BNIL); 
BgL_g1045z00_1005 = BgL_list1190z00_1030; } 
{ 
long BgL_iz00_1007;obj_t BgL_rz00_1008;
BgL_iz00_1007 = BgL_g1044z00_1004; 
BgL_rz00_1008 = BgL_g1045z00_1005; 
BgL_zc3anonymousza31159ze3z83_1009:
if(
(BgL_iz00_1007>=BgL_nz00_31))
{ /* Unsafe/regexp.scm 151 */
obj_t BgL_arg1162z00_1011;
{ /* Unsafe/regexp.scm 151 */
obj_t BgL_arg1166z00_1014;
BgL_arg1166z00_1014 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(
bgl_reverse_bang(BgL_rz00_1008)); 
{ /* Ieee/number.scm 165 */

BgL_arg1162z00_1011 = 
BGl_stringzd2ze3numberz31zz__r4_numbers_6_5z00(BgL_arg1166z00_1014, 
BINT(((long)10))); } } 
{ /* Unsafe/regexp.scm 151 */
obj_t BgL_list1163z00_1012;
{ /* Unsafe/regexp.scm 151 */
obj_t BgL_arg1165z00_1013;
BgL_arg1165z00_1013 = 
MAKE_YOUNG_PAIR(
BINT(BgL_iz00_1007), BNIL); 
BgL_list1163z00_1012 = 
MAKE_YOUNG_PAIR(BgL_arg1162z00_1011, BgL_arg1165z00_1013); } 
return BgL_list1163z00_1012;} }  else 
{ /* Unsafe/regexp.scm 152 */
unsigned char BgL_cz00_1018;
BgL_cz00_1018 = 
STRING_REF(BgL_sz00_29, BgL_iz00_1007); 
{ /* Unsafe/regexp.scm 153 */
bool_t BgL_testz00_2278;
{ /* Unsafe/regexp.scm 153 */
bool_t BgL_res1628z00_1566;
BgL_res1628z00_1566 = 
isdigit(BgL_cz00_1018); 
BgL_testz00_2278 = BgL_res1628z00_1566; } 
if(BgL_testz00_2278)
{ /* Unsafe/regexp.scm 154 */
long BgL_arg1170z00_1020;obj_t BgL_arg1171z00_1021;
BgL_arg1170z00_1020 = 
(BgL_iz00_1007+((long)1)); 
BgL_arg1171z00_1021 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_cz00_1018), BgL_rz00_1008); 
{ 
obj_t BgL_rz00_2284;long BgL_iz00_2283;
BgL_iz00_2283 = BgL_arg1170z00_1020; 
BgL_rz00_2284 = BgL_arg1171z00_1021; 
BgL_rz00_1008 = BgL_rz00_2284; 
BgL_iz00_1007 = BgL_iz00_2283; 
goto BgL_zc3anonymousza31159ze3z83_1009;} }  else 
{ /* Unsafe/regexp.scm 155 */
obj_t BgL_arg1178z00_1022;
{ /* Unsafe/regexp.scm 155 */
obj_t BgL_arg1187z00_1025;
BgL_arg1187z00_1025 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(
bgl_reverse_bang(BgL_rz00_1008)); 
{ /* Ieee/number.scm 165 */

BgL_arg1178z00_1022 = 
BGl_stringzd2ze3numberz31zz__r4_numbers_6_5z00(BgL_arg1187z00_1025, 
BINT(((long)10))); } } 
{ /* Unsafe/regexp.scm 155 */
obj_t BgL_list1179z00_1023;
{ /* Unsafe/regexp.scm 155 */
obj_t BgL_arg1181z00_1024;
BgL_arg1181z00_1024 = 
MAKE_YOUNG_PAIR(
BINT(BgL_iz00_1007), BNIL); 
BgL_list1179z00_1023 = 
MAKE_YOUNG_PAIR(BgL_arg1178z00_1022, BgL_arg1181z00_1024); } 
return BgL_list1179z00_1023;} } } } } }  else 
{ /* Unsafe/regexp.scm 148 */
return BFALSE;} } }  else 
{ /* Unsafe/regexp.scm 146 */
return BFALSE;} } 
BGL_FUNCTION_END;
}



/* pregexp-list-ref */
obj_t BGl_pregexpzd2listzd2refz00zz__regexpz00(obj_t BgL_sz00_32, obj_t BgL_iz00_33)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 161 */
{ 
obj_t BgL_sz00_1034;long BgL_kz00_1035;
BgL_sz00_1034 = BgL_sz00_32; 
BgL_kz00_1035 = ((long)0); 
BgL_zc3anonymousza31196ze3z83_1036:
if(
NULLP(BgL_sz00_1034))
{ /* Unsafe/regexp.scm 165 */
return BFALSE;}  else 
{ /* Unsafe/regexp.scm 165 */
if(
(BgL_kz00_1035==
(long)CINT(BgL_iz00_33)))
{ /* Unsafe/regexp.scm 166 */
return 
CAR(
((obj_t)BgL_sz00_1034));}  else 
{ 
long BgL_kz00_2302;obj_t BgL_sz00_2299;
BgL_sz00_2299 = 
CDR(
((obj_t)BgL_sz00_1034)); 
BgL_kz00_2302 = 
(BgL_kz00_1035+((long)1)); 
BgL_kz00_1035 = BgL_kz00_2302; 
BgL_sz00_1034 = BgL_sz00_2299; 
goto BgL_zc3anonymousza31196ze3z83_1036;} } } } 
BGL_FUNCTION_END;
}



/* pregexp-replace-aux */
obj_t BGl_pregexpzd2replacezd2auxz00zz__regexpz00(obj_t BgL_strz00_34, obj_t BgL_insz00_35, long BgL_nz00_36, obj_t BgL_backrefsz00_37)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 172 */
{ 
obj_t BgL_iz00_1043;obj_t BgL_rz00_1044;
BgL_iz00_1043 = 
BINT(((long)0)); 
BgL_rz00_1044 = BGl_string1780z00zz__regexpz00; 
BgL_zc3anonymousza31202ze3z83_1045:
if(
(
(long)CINT(BgL_iz00_1043)>=BgL_nz00_36))
{ /* Unsafe/regexp.scm 174 */
return BgL_rz00_1044;}  else 
{ /* Unsafe/regexp.scm 175 */
unsigned char BgL_cz00_1047;
BgL_cz00_1047 = 
STRING_REF(BgL_insz00_35, 
(long)CINT(BgL_iz00_1043)); 
if(
(BgL_cz00_1047==((unsigned char)'\\')))
{ /* Unsafe/regexp.scm 177 */
obj_t BgL_brzd2izd2_1049;
BgL_brzd2izd2_1049 = 
BGl_pregexpzd2readzd2escapedzd2numberzd2zz__regexpz00(BgL_insz00_35, BgL_iz00_1043, BgL_nz00_36); 
{ /* Unsafe/regexp.scm 177 */
obj_t BgL_brz00_1050;
if(
CBOOL(BgL_brzd2izd2_1049))
{ /* Unsafe/regexp.scm 178 */
BgL_brz00_1050 = 
CAR(
((obj_t)BgL_brzd2izd2_1049)); }  else 
{ /* Unsafe/regexp.scm 178 */
if(
(
STRING_REF(BgL_insz00_35, 
(
(long)CINT(BgL_iz00_1043)+((long)1)))==((unsigned char)'&')))
{ /* Unsafe/regexp.scm 179 */
BgL_brz00_1050 = 
BINT(((long)0)); }  else 
{ /* Unsafe/regexp.scm 179 */
BgL_brz00_1050 = BFALSE; } } 
{ /* Unsafe/regexp.scm 178 */
obj_t BgL_iz00_1051;
if(
CBOOL(BgL_brzd2izd2_1049))
{ /* Unsafe/regexp.scm 181 */
obj_t BgL_pairz00_1599;
BgL_pairz00_1599 = 
CDR(
((obj_t)BgL_brzd2izd2_1049)); 
BgL_iz00_1051 = 
CAR(BgL_pairz00_1599); }  else 
{ /* Unsafe/regexp.scm 181 */
if(
CBOOL(BgL_brz00_1050))
{ /* Unsafe/regexp.scm 182 */
BgL_iz00_1051 = 
ADDFX(BgL_iz00_1043, 
BINT(((long)2))); }  else 
{ /* Unsafe/regexp.scm 182 */
BgL_iz00_1051 = 
ADDFX(BgL_iz00_1043, 
BINT(((long)1))); } } 
{ /* Unsafe/regexp.scm 181 */

if(
CBOOL(BgL_brz00_1050))
{ /* Unsafe/regexp.scm 190 */
obj_t BgL_arg1205z00_1052;
{ /* Unsafe/regexp.scm 190 */
obj_t BgL_backrefz00_1053;
BgL_backrefz00_1053 = 
BGl_pregexpzd2listzd2refz00zz__regexpz00(BgL_backrefsz00_37, BgL_brz00_1050); 
if(
CBOOL(BgL_backrefz00_1053))
{ /* Unsafe/regexp.scm 193 */
obj_t BgL_arg1206z00_1054;
{ /* Unsafe/regexp.scm 193 */
obj_t BgL_arg1207z00_1055;obj_t BgL_arg1208z00_1056;
BgL_arg1207z00_1055 = 
CAR(
((obj_t)BgL_backrefz00_1053)); 
BgL_arg1208z00_1056 = 
CDR(
((obj_t)BgL_backrefz00_1053)); 
BgL_arg1206z00_1054 = 
c_substring(BgL_strz00_34, 
(long)CINT(BgL_arg1207z00_1055), 
(long)CINT(BgL_arg1208z00_1056)); } 
BgL_arg1205z00_1052 = 
string_append(BgL_rz00_1044, BgL_arg1206z00_1054); }  else 
{ /* Unsafe/regexp.scm 191 */
BgL_arg1205z00_1052 = BgL_rz00_1044; } } 
{ 
obj_t BgL_rz00_2347;obj_t BgL_iz00_2346;
BgL_iz00_2346 = BgL_iz00_1051; 
BgL_rz00_2347 = BgL_arg1205z00_1052; 
BgL_rz00_1044 = BgL_rz00_2347; 
BgL_iz00_1043 = BgL_iz00_2346; 
goto BgL_zc3anonymousza31202ze3z83_1045;} }  else 
{ /* Unsafe/regexp.scm 185 */
unsigned char BgL_c2z00_1057;
BgL_c2z00_1057 = 
STRING_REF(BgL_insz00_35, 
(long)CINT(BgL_iz00_1051)); 
{ /* Unsafe/regexp.scm 186 */
long BgL_arg1212z00_1058;obj_t BgL_arg1213z00_1059;
BgL_arg1212z00_1058 = 
(
(long)CINT(BgL_iz00_1051)+((long)1)); 
if(
(BgL_c2z00_1057==((unsigned char)'$')))
{ /* Unsafe/regexp.scm 187 */
BgL_arg1213z00_1059 = BgL_rz00_1044; }  else 
{ /* Unsafe/regexp.scm 188 */
obj_t BgL_arg1215z00_1061;
{ /* Unsafe/regexp.scm 188 */
obj_t BgL_list1216z00_1062;
BgL_list1216z00_1062 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_c2z00_1057), BNIL); 
BgL_arg1215z00_1061 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list1216z00_1062); } 
BgL_arg1213z00_1059 = 
string_append(BgL_rz00_1044, BgL_arg1215z00_1061); } 
{ 
obj_t BgL_rz00_2360;obj_t BgL_iz00_2358;
BgL_iz00_2358 = 
BINT(BgL_arg1212z00_1058); 
BgL_rz00_2360 = BgL_arg1213z00_1059; 
BgL_rz00_1044 = BgL_rz00_2360; 
BgL_iz00_1043 = BgL_iz00_2358; 
goto BgL_zc3anonymousza31202ze3z83_1045;} } } } } } }  else 
{ /* Unsafe/regexp.scm 195 */
long BgL_arg1224z00_1068;obj_t BgL_arg1225z00_1069;
BgL_arg1224z00_1068 = 
(
(long)CINT(BgL_iz00_1043)+((long)1)); 
{ /* Unsafe/regexp.scm 195 */
obj_t BgL_arg1227z00_1070;
{ /* Unsafe/regexp.scm 195 */
obj_t BgL_list1228z00_1071;
BgL_list1228z00_1071 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_cz00_1047), BNIL); 
BgL_arg1227z00_1070 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list1228z00_1071); } 
BgL_arg1225z00_1069 = 
string_append(BgL_rz00_1044, BgL_arg1227z00_1070); } 
{ 
obj_t BgL_rz00_2369;obj_t BgL_iz00_2367;
BgL_iz00_2367 = 
BINT(BgL_arg1224z00_1068); 
BgL_rz00_2369 = BgL_arg1225z00_1069; 
BgL_rz00_1044 = BgL_rz00_2369; 
BgL_iz00_1043 = BgL_iz00_2367; 
goto BgL_zc3anonymousza31202ze3z83_1045;} } } } } 
BGL_FUNCTION_END;
}



/* pregexp-split */
BGL_EXPORTED_DEF obj_t BGl_pregexpzd2splitzd2zz__regexpz00(obj_t BgL_patz00_38, obj_t BgL_strz00_39)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 200 */
{ /* Unsafe/regexp.scm 202 */
long BgL_nz00_1073;
BgL_nz00_1073 = 
STRING_LENGTH(BgL_strz00_39); 
{ 
obj_t BgL_iz00_1076;obj_t BgL_rz00_1077;bool_t BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_1078;
BgL_iz00_1076 = 
BINT(((long)0)); 
BgL_rz00_1077 = BNIL; 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_1078 = ((bool_t)0); 
BgL_zc3anonymousza31229ze3z83_1079:
if(
(
(long)CINT(BgL_iz00_1076)>=BgL_nz00_1073))
{ /* Unsafe/regexp.scm 204 */
return 
bgl_reverse_bang(BgL_rz00_1077);}  else 
{ /* Unsafe/regexp.scm 205 */
obj_t BgL_g1047z00_1081;
BgL_g1047z00_1081 = 
BGl_pregexpzd2matchzd2positionsz00zz__regexpz00(BgL_patz00_38, BgL_strz00_39, BgL_iz00_1076, 
BINT(BgL_nz00_1073)); 
if(
CBOOL(BgL_g1047z00_1081))
{ /* Unsafe/regexp.scm 208 */
obj_t BgL_jkz00_1084;
BgL_jkz00_1084 = 
CAR(
((obj_t)BgL_g1047z00_1081)); 
{ /* Unsafe/regexp.scm 209 */
obj_t BgL_jz00_1085;obj_t BgL_kz00_1086;
BgL_jz00_1085 = 
CAR(
((obj_t)BgL_jkz00_1084)); 
BgL_kz00_1086 = 
CDR(
((obj_t)BgL_jkz00_1084)); 
if(
(
(long)CINT(BgL_jz00_1085)==
(long)CINT(BgL_kz00_1086)))
{ /* Unsafe/regexp.scm 211 */
long BgL_arg1233z00_1088;obj_t BgL_arg1234z00_1089;
BgL_arg1233z00_1088 = 
(
(long)CINT(BgL_kz00_1086)+((long)1)); 
BgL_arg1234z00_1089 = 
MAKE_YOUNG_PAIR(
c_substring(BgL_strz00_39, 
(long)CINT(BgL_iz00_1076), 
(
(long)CINT(BgL_jz00_1085)+((long)1))), BgL_rz00_1077); 
{ 
bool_t BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2400;obj_t BgL_rz00_2399;obj_t BgL_iz00_2397;
BgL_iz00_2397 = 
BINT(BgL_arg1233z00_1088); 
BgL_rz00_2399 = BgL_arg1234z00_1089; 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2400 = ((bool_t)1); 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_1078 = BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2400; 
BgL_rz00_1077 = BgL_rz00_2399; 
BgL_iz00_1076 = BgL_iz00_2397; 
goto BgL_zc3anonymousza31229ze3z83_1079;} }  else 
{ /* Unsafe/regexp.scm 213 */
bool_t BgL_testz00_2401;
if(
(
(long)CINT(BgL_jz00_1085)==
(long)CINT(BgL_iz00_1076)))
{ /* Unsafe/regexp.scm 213 */
BgL_testz00_2401 = BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_1078
; }  else 
{ /* Unsafe/regexp.scm 213 */
BgL_testz00_2401 = ((bool_t)0)
; } 
if(BgL_testz00_2401)
{ 
bool_t BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2407;obj_t BgL_iz00_2406;
BgL_iz00_2406 = BgL_kz00_1086; 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2407 = ((bool_t)0); 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_1078 = BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2407; 
BgL_iz00_1076 = BgL_iz00_2406; 
goto BgL_zc3anonymousza31229ze3z83_1079;}  else 
{ /* Unsafe/regexp.scm 216 */
obj_t BgL_arg1239z00_1094;
BgL_arg1239z00_1094 = 
MAKE_YOUNG_PAIR(
c_substring(BgL_strz00_39, 
(long)CINT(BgL_iz00_1076), 
(long)CINT(BgL_jz00_1085)), BgL_rz00_1077); 
{ 
bool_t BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2414;obj_t BgL_rz00_2413;obj_t BgL_iz00_2412;
BgL_iz00_2412 = BgL_kz00_1086; 
BgL_rz00_2413 = BgL_arg1239z00_1094; 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2414 = ((bool_t)0); 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_1078 = BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2414; 
BgL_rz00_1077 = BgL_rz00_2413; 
BgL_iz00_1076 = BgL_iz00_2412; 
goto BgL_zc3anonymousza31229ze3z83_1079;} } } } }  else 
{ /* Unsafe/regexp.scm 217 */
obj_t BgL_arg1242z00_1097;
BgL_arg1242z00_1097 = 
MAKE_YOUNG_PAIR(
c_substring(BgL_strz00_39, 
(long)CINT(BgL_iz00_1076), BgL_nz00_1073), BgL_rz00_1077); 
{ 
bool_t BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2421;obj_t BgL_rz00_2420;obj_t BgL_iz00_2418;
BgL_iz00_2418 = 
BINT(BgL_nz00_1073); 
BgL_rz00_2420 = BgL_arg1242z00_1097; 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2421 = ((bool_t)0); 
BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_1078 = BgL_pickedzd2upzd2onezd2undelimitedzd2charzf3zf3_2421; 
BgL_rz00_1077 = BgL_rz00_2420; 
BgL_iz00_1076 = BgL_iz00_2418; 
goto BgL_zc3anonymousza31229ze3z83_1079;} } } } } } 
BGL_FUNCTION_END;
}



/* &pregexp-split */
obj_t BGl_z62pregexpzd2splitzb0zz__regexpz00(obj_t BgL_envz00_1970, obj_t BgL_patz00_1971, obj_t BgL_strz00_1972)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 200 */
{ /* Unsafe/regexp.scm 202 */
obj_t BgL_auxz00_2423;
if(
STRINGP(BgL_strz00_1972))
{ /* Unsafe/regexp.scm 202 */
BgL_auxz00_2423 = BgL_strz00_1972
; }  else 
{ 
obj_t BgL_auxz00_2426;
BgL_auxz00_2426 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)8498)), BGl_string1781z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_1972); 
FAILURE(BgL_auxz00_2426,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2splitzd2zz__regexpz00(BgL_patz00_1971, BgL_auxz00_2423);} } 
BGL_FUNCTION_END;
}



/* pregexp-replace */
BGL_EXPORTED_DEF obj_t BGl_pregexpzd2replacezd2zz__regexpz00(obj_t BgL_patz00_40, obj_t BgL_strz00_41, obj_t BgL_insz00_42)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 222 */
{ /* Unsafe/regexp.scm 223 */
long BgL_nz00_1100;
BgL_nz00_1100 = 
STRING_LENGTH(BgL_strz00_41); 
{ /* Unsafe/regexp.scm 223 */
obj_t BgL_ppz00_1101;
BgL_ppz00_1101 = 
BGl_matchz00zz__regexpz00(BgL_patz00_40, BgL_strz00_41, ((bool_t)0), 
BINT(((long)0)), 
BINT(BgL_nz00_1100)); 
{ /* Unsafe/regexp.scm 224 */

if(
CBOOL(BgL_ppz00_1101))
{ /* Unsafe/regexp.scm 226 */
long BgL_inszd2lenzd2_1102;obj_t BgL_mzd2izd2_1103;obj_t BgL_mzd2nzd2_1104;
BgL_inszd2lenzd2_1102 = 
STRING_LENGTH(BgL_insz00_42); 
{ /* Unsafe/regexp.scm 227 */
obj_t BgL_pairz00_1660;
BgL_pairz00_1660 = 
CAR(
((obj_t)BgL_ppz00_1101)); 
BgL_mzd2izd2_1103 = 
CAR(BgL_pairz00_1660); } 
{ /* Unsafe/regexp.scm 228 */
obj_t BgL_pairz00_1664;
BgL_pairz00_1664 = 
CAR(
((obj_t)BgL_ppz00_1101)); 
BgL_mzd2nzd2_1104 = 
CDR(BgL_pairz00_1664); } 
return 
string_append_3(
c_substring(BgL_strz00_41, ((long)0), 
(long)CINT(BgL_mzd2izd2_1103)), 
BGl_pregexpzd2replacezd2auxz00zz__regexpz00(BgL_strz00_41, BgL_insz00_42, BgL_inszd2lenzd2_1102, BgL_ppz00_1101), 
c_substring(BgL_strz00_41, 
(long)CINT(BgL_mzd2nzd2_1104), BgL_nz00_1100));}  else 
{ /* Unsafe/regexp.scm 225 */
return BgL_strz00_41;} } } } } 
BGL_FUNCTION_END;
}



/* &pregexp-replace */
obj_t BGl_z62pregexpzd2replacezb0zz__regexpz00(obj_t BgL_envz00_1973, obj_t BgL_patz00_1974, obj_t BgL_strz00_1975, obj_t BgL_insz00_1976)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 222 */
{ /* Unsafe/regexp.scm 223 */
obj_t BgL_auxz00_2457;obj_t BgL_auxz00_2450;
if(
STRINGP(BgL_insz00_1976))
{ /* Unsafe/regexp.scm 223 */
BgL_auxz00_2457 = BgL_insz00_1976
; }  else 
{ 
obj_t BgL_auxz00_2460;
BgL_auxz00_2460 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)9314)), BGl_string1782z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_insz00_1976); 
FAILURE(BgL_auxz00_2460,BFALSE,BFALSE);} 
if(
STRINGP(BgL_strz00_1975))
{ /* Unsafe/regexp.scm 223 */
BgL_auxz00_2450 = BgL_strz00_1975
; }  else 
{ 
obj_t BgL_auxz00_2453;
BgL_auxz00_2453 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)9314)), BGl_string1782z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_1975); 
FAILURE(BgL_auxz00_2453,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2replacezd2zz__regexpz00(BgL_patz00_1974, BgL_auxz00_2450, BgL_auxz00_2457);} } 
BGL_FUNCTION_END;
}



/* pregexp-replace* */
BGL_EXPORTED_DEF obj_t BGl_pregexpzd2replaceza2z70zz__regexpz00(obj_t BgL_patz00_43, obj_t BgL_strz00_44, obj_t BgL_insz00_45)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 237 */
{ /* Unsafe/regexp.scm 240 */
obj_t BgL_patz00_1108;long BgL_nz00_1109;long BgL_inszd2lenzd2_1110;
if(
STRINGP(BgL_patz00_43))
{ /* Unsafe/regexp.scm 240 */
BgL_patz00_1108 = 
bgl_regcomp(BgL_patz00_43, BNIL); }  else 
{ /* Unsafe/regexp.scm 240 */
BgL_patz00_1108 = BgL_patz00_43; } 
BgL_nz00_1109 = 
STRING_LENGTH(BgL_strz00_44); 
BgL_inszd2lenzd2_1110 = 
STRING_LENGTH(BgL_insz00_45); 
{ 
obj_t BgL_iz00_1112;obj_t BgL_rz00_1113;
BgL_iz00_1112 = 
BINT(((long)0)); 
BgL_rz00_1113 = BGl_string1780z00zz__regexpz00; 
BgL_zc3anonymousza31248ze3z83_1114:
if(
(
(long)CINT(BgL_iz00_1112)>=BgL_nz00_1109))
{ /* Unsafe/regexp.scm 246 */
return BgL_rz00_1113;}  else 
{ /* Unsafe/regexp.scm 247 */
obj_t BgL_ppz00_1116;
BgL_ppz00_1116 = 
BGl_pregexpzd2matchzd2positionsz00zz__regexpz00(BgL_patz00_1108, BgL_strz00_44, BgL_iz00_1112, 
BINT(BgL_nz00_1109)); 
if(
CBOOL(BgL_ppz00_1116))
{ /* Unsafe/regexp.scm 258 */
obj_t BgL_arg1251z00_1117;obj_t BgL_arg1252z00_1118;
{ /* Unsafe/regexp.scm 258 */
obj_t BgL_pairz00_1684;
BgL_pairz00_1684 = 
CAR(
((obj_t)BgL_ppz00_1116)); 
BgL_arg1251z00_1117 = 
CDR(BgL_pairz00_1684); } 
{ /* Unsafe/regexp.scm 261 */
obj_t BgL_arg1254z00_1119;obj_t BgL_arg1256z00_1120;
{ /* Unsafe/regexp.scm 261 */
obj_t BgL_arg1257z00_1121;
{ /* Unsafe/regexp.scm 261 */
obj_t BgL_pairz00_1688;
BgL_pairz00_1688 = 
CAR(
((obj_t)BgL_ppz00_1116)); 
BgL_arg1257z00_1121 = 
CAR(BgL_pairz00_1688); } 
BgL_arg1254z00_1119 = 
c_substring(BgL_strz00_44, 
(long)CINT(BgL_iz00_1112), 
(long)CINT(BgL_arg1257z00_1121)); } 
BgL_arg1256z00_1120 = 
BGl_pregexpzd2replacezd2auxz00zz__regexpz00(BgL_strz00_44, BgL_insz00_45, BgL_inszd2lenzd2_1110, BgL_ppz00_1116); 
BgL_arg1252z00_1118 = 
string_append_3(BgL_rz00_1113, BgL_arg1254z00_1119, BgL_arg1256z00_1120); } 
{ 
obj_t BgL_rz00_2489;obj_t BgL_iz00_2488;
BgL_iz00_2488 = BgL_arg1251z00_1117; 
BgL_rz00_2489 = BgL_arg1252z00_1118; 
BgL_rz00_1113 = BgL_rz00_2489; 
BgL_iz00_1112 = BgL_iz00_2488; 
goto BgL_zc3anonymousza31248ze3z83_1114;} }  else 
{ /* Unsafe/regexp.scm 248 */
if(
(
(long)CINT(BgL_iz00_1112)==((long)0)))
{ /* Unsafe/regexp.scm 249 */
return BgL_strz00_44;}  else 
{ /* Unsafe/regexp.scm 249 */
return 
string_append(BgL_rz00_1113, 
c_substring(BgL_strz00_44, 
(long)CINT(BgL_iz00_1112), BgL_nz00_1109));} } } } } } 
BGL_FUNCTION_END;
}



/* &pregexp-replace* */
obj_t BGl_z62pregexpzd2replaceza2z12zz__regexpz00(obj_t BgL_envz00_1977, obj_t BgL_patz00_1978, obj_t BgL_strz00_1979, obj_t BgL_insz00_1980)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 237 */
{ /* Unsafe/regexp.scm 240 */
obj_t BgL_auxz00_2504;obj_t BgL_auxz00_2497;
if(
STRINGP(BgL_insz00_1980))
{ /* Unsafe/regexp.scm 240 */
BgL_auxz00_2504 = BgL_insz00_1980
; }  else 
{ 
obj_t BgL_auxz00_2507;
BgL_auxz00_2507 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)9938)), BGl_string1783z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_insz00_1980); 
FAILURE(BgL_auxz00_2507,BFALSE,BFALSE);} 
if(
STRINGP(BgL_strz00_1979))
{ /* Unsafe/regexp.scm 240 */
BgL_auxz00_2497 = BgL_strz00_1979
; }  else 
{ 
obj_t BgL_auxz00_2500;
BgL_auxz00_2500 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)9938)), BGl_string1783z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_strz00_1979); 
FAILURE(BgL_auxz00_2500,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2replaceza2z70zz__regexpz00(BgL_patz00_1978, BgL_auxz00_2497, BgL_auxz00_2504);} } 
BGL_FUNCTION_END;
}



/* pregexp-quote */
BGL_EXPORTED_DEF obj_t BGl_pregexpzd2quotezd2zz__regexpz00(obj_t BgL_sz00_46)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 267 */
{ /* Unsafe/regexp.scm 268 */
long BgL_g1049z00_1127;
BgL_g1049z00_1127 = 
(
STRING_LENGTH(BgL_sz00_46)-((long)1)); 
{ 
long BgL_iz00_1130;obj_t BgL_rz00_1131;
BgL_iz00_1130 = BgL_g1049z00_1127; 
BgL_rz00_1131 = BNIL; 
BgL_zc3anonymousza31262ze3z83_1132:
if(
(BgL_iz00_1130<((long)0)))
{ /* Unsafe/regexp.scm 269 */
return 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_rz00_1131);}  else 
{ /* Unsafe/regexp.scm 271 */
long BgL_arg1264z00_1134;obj_t BgL_arg1268z00_1135;
BgL_arg1264z00_1134 = 
(BgL_iz00_1130-((long)1)); 
{ /* Unsafe/regexp.scm 272 */
unsigned char BgL_cz00_1136;
BgL_cz00_1136 = 
STRING_REF(BgL_sz00_46, BgL_iz00_1130); 
if(
CBOOL(
BGl_memvz00zz__r4_pairs_and_lists_6_3z00(
BCHAR(BgL_cz00_1136), BGl_list1784z00zz__regexpz00)))
{ /* Unsafe/regexp.scm 275 */
obj_t BgL_arg1270z00_1138;
BgL_arg1270z00_1138 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_cz00_1136), BgL_rz00_1131); 
BgL_arg1268z00_1135 = 
MAKE_YOUNG_PAIR(
BCHAR(((unsigned char)'\\')), BgL_arg1270z00_1138); }  else 
{ /* Unsafe/regexp.scm 273 */
BgL_arg1268z00_1135 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_cz00_1136), BgL_rz00_1131); } } 
{ 
obj_t BgL_rz00_2530;long BgL_iz00_2529;
BgL_iz00_2529 = BgL_arg1264z00_1134; 
BgL_rz00_2530 = BgL_arg1268z00_1135; 
BgL_rz00_1131 = BgL_rz00_2530; 
BgL_iz00_1130 = BgL_iz00_2529; 
goto BgL_zc3anonymousza31262ze3z83_1132;} } } } } 
BGL_FUNCTION_END;
}



/* &pregexp-quote */
obj_t BGl_z62pregexpzd2quotezb0zz__regexpz00(obj_t BgL_envz00_1981, obj_t BgL_sz00_1982)
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 267 */
{ /* Unsafe/regexp.scm 268 */
obj_t BgL_auxz00_2531;
if(
STRINGP(BgL_sz00_1982))
{ /* Unsafe/regexp.scm 268 */
BgL_auxz00_2531 = BgL_sz00_1982
; }  else 
{ 
obj_t BgL_auxz00_2534;
BgL_auxz00_2534 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1770z00zz__regexpz00, 
BINT(((long)10899)), BGl_string1785z00zz__regexpz00, BGl_string1774z00zz__regexpz00, BgL_sz00_1982); 
FAILURE(BgL_auxz00_2534,BFALSE,BFALSE);} 
return 
BGl_pregexpzd2quotezd2zz__regexpz00(BgL_auxz00_2531);} } 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__regexpz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 16 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__regexpz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 16 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__regexpz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 16 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__regexpz00()
{ BGL_FUNCTION_BEGIN;
{ /* Unsafe/regexp.scm 16 */
return 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)430898742), 
BSTRING_TO_STRING(BGl_string1786z00zz__regexpz00));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
